﻿using System;


namespace CasinoWars
{
    public class CasinoWarsApp
    {
        public static void Main()
        {
            string invalue;
            CasinoData casino = new CasinoData();

            DisplayIntro();
            Console.Clear();

            /*Obtain Player Data: First and Last Name, and Money Amount, with
             * error controls for empty data if enter is pressed, or invalid data
             * in the case of int or double types*/
            do
            {
                Console.WriteLine();
                Console.Write("\tPlease enter your first name: ");
                casino.pfname = Console.ReadLine();
                if (casino.pfname == "")
                {
                    Console.WriteLine();
                    Console.WriteLine("\tYou must enter your first name.");
                    Console.WriteLine();
                    Console.Write("\tPlease enter your first name: ");
                    casino.pfname = Console.ReadLine();
                }
            }
            while (casino.pfname == "");

            do
            {
                Console.Write("\tPlease enter your last name: ");
                casino.plname = Console.ReadLine();
                if (casino.plname == "")
                {
                    Console.WriteLine();
                    Console.WriteLine("\tYou must enter your last name.");
                    Console.WriteLine();
                    Console.Write("\tPlease enter your last name: ");
                    casino.plname = Console.ReadLine();
                }
            }
            while (casino.plname == "");

            Console.Clear();

            do
            {
                Console.WriteLine();
                Console.Write("\tPlease enter the amount of money you will start with: ");
                invalue = Console.ReadLine();
                double tempmoney;
                bool isValidDouble = Double.TryParse((invalue), out tempmoney);
                do
                {
                    if (isValidDouble == false)
                    {
                        Console.WriteLine();
                        Console.WriteLine("\tYou must enter a Numerical Value");
                        Console.WriteLine();
                        Console.Write("\tPlease enter the amount of money you will start with: ");
                        invalue = Console.ReadLine();
                        isValidDouble = Double.TryParse((invalue), out tempmoney);

                    }
                }
                while (isValidDouble == false);
                casino.aomoney = tempmoney;
  
            }
            while (invalue == "" && casino.aomoney > 0);
            Console.Clear();
            Console.WriteLine();
            Console.WriteLine("\tWelcome {0} {1} you have {2:C} to play with!", casino.pfname, casino.plname, casino.aomoney);
            Console.WriteLine("\tPlease Press Enter after verifying your information");

            Console.ReadLine();
            Console.Clear();

            casino.pagain = "";

            do
            {
                casino.PlaceYourBet();

                /*Generate Card numbers*/
                casino.GeneratePlayerCard();
                casino.DisplayPlayerCard();
                casino.GenerateDealerCard();
                casino.DisplayDealerCard();

                /*Determine Winner*/
                casino.DetermineWinner(casino.pcard, casino.dcard);
                casino.DisplayWinnerandAdjust();
                
                /* Checks to See if Player still has Money and offers them the
                 * chance to add more money if they are at 0.  If Player Adds
                 * more money they game continues, if they select not to Add
                 * more money the player recieves a goodbye message and the program
                 * closes*/

                if (casino.aomoney == 0)
                {
                    Console.WriteLine();
                    Console.WriteLine("\tYou are out of Money");
                    Console.WriteLine();
                    string addmoney;
                    Console.Write("\tWould you like to add more money?(y/n)");
                    addmoney = Console.ReadLine();
                    do
                    {
                        /* Checks for y or n when attempting to add money, string input
                         * other than y or n is rejected*/

                        if (addmoney != "y" && addmoney != "n")
                        {
                            Console.WriteLine();
                            Console.WriteLine("Please Enter y for yes or n for no");
                            Console.WriteLine();
                            Console.Write("\tWould you like to add more money?(y/n)");
                            addmoney = Console.ReadLine();
                        }
                    } while (addmoney != "y" && addmoney != "n");
                    if (addmoney == "y")
                    {
                        Console.WriteLine();
                        Console.Write("\tHow much do you want to add?");
                        invalue = Console.ReadLine();
                        double tempmoney;
                        bool isValidDouble = Double.TryParse((invalue), out tempmoney);
                        do
                        {
                            if (isValidDouble == false)
                            {
                                Console.WriteLine();
                                Console.WriteLine("\tYou must enter a Numerical Value");
                                Console.WriteLine();
                                Console.Write("\tHow much do you want to add?");
                                invalue = Console.ReadLine();
                                isValidDouble = Double.TryParse((invalue), out tempmoney);

                            }
                        }
                        while (isValidDouble == false);
                        casino.aomoney = tempmoney;
                        Console.WriteLine("\tYou now have {0:C}", casino.aomoney);
                    }
                    else if (addmoney == "n")
                    {
                        Console.Clear();
                        Console.WriteLine();
                        Console.WriteLine("\t Thank you for playing Casino Wars");
                        Console.ReadLine();
                        return;
                    }
                }
                /* Gives the player the option to Continue playing, of quit*/
               
                Console.WriteLine();
                Console.WriteLine("\tIf you want to Keep playing Press Enter");
                Console.Write("\tIf you want to Quit Enter the Letter q:");
                casino.pagain = Console.ReadLine();
                do
                {
                    if (casino.pagain != "q" && casino.pagain != "")
                    {
                        casino.pagain = "";
                        Console.WriteLine();
                        Console.WriteLine("\tIf you want to Keep playing Press Enter");
                        Console.Write("\tIf you want to Quit Enter the Letter q:");
                        casino.pagain = Console.ReadLine();
                    }
                }
                while (casino.pagain != "q" && casino.pagain != "");
            }
            while (casino.pagain != "q");

            DisplayGoodBye();
        }


        public static void DisplayIntro()
        {
            Console.WriteLine();
            Console.WriteLine("\t-=-  Welcome to Casino Wars -=-");
            Console.WriteLine("\t     Press Enter to Continue");
            Console.ReadLine();
        }

        public static void DisplayGoodBye()
        {
            Console.Clear();
            Console.WriteLine();
            Console.WriteLine("\t Thank you for playing Casino Wars");
            Console.ReadLine();
        }
    }
}
            
